LINUX.ORG.RU

Не работает vaapi на i3-4340/HD Graphics 4600.


0

1

ОС Ubuntu Linux 13.04 64-bit.

Проц Intel(R) Core(TM) i3-4340 CPU содержит HD Graphics 4600 согласно http://ark.intel.com/products/77771/

Поставил драйвер:

sudo add-apt-repository ppa:xorg-edgers/ppa
sudo apt-get update && sudo apt-get upgrade
Стало:
OpenGL renderer string: Mesa DRI Intel(R) Haswell Desktop 
OpenGL core profile version string: 3.1 (Core Profile) Mesa 9.1.7
т.е. Mesa 9.1.7, DRI какие-то модули актуальные.

sudo vainfo
libva: VA-API version 0.32.0
libva: va_getDriverName() returns 0
libva: Trying to open /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so
libva error: /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so init failed
libva: va_openDriver() returns -1
vaInitialize failed with error code -1 (unknown libva error),exit

Пакет libva-intel-vaapi-driver стоит.

Что ему надо? Intel, которая Linux-friendly, с довольно свежим дистрибутивом, с картой, которая Intel Graphics HD 4000 и поддерживает аппаратное декодирование H264...

Вопрос: как заставить работать? Это так Intel простому пользователю на Linux облегчила жизнь?

Пакет libva-intel-vaapi-driver стоит.

В Raring версия 1.0.17, которая вышла 20 месяцев назад. Не уверен, что тогда Haswell даже был анонсирован. Поставь версию поновее, скажем 1.2.1.

i-rinat ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

cat /var/log/Xorg.0.log :

[ 21.212] (II) Module fbdevhw: vendor=«X.Org Foundation» [ 21.212] compiled for 1.13.4, module version = 0.0.2 [ 21.212] ABI class: X.Org Video Driver, version 13.1 [ 21.212] (II) intel(0): Creating default Display subsection in Screen section «Default Screen Section» for depth/fbbpp 24/32 [ 21.212] (==) intel(0): Depth 24, (--) framebuffer bpp 32 [ 21.212] (==) intel(0): RGB weight 888 [ 21.212] (==) intel(0): Default visual is TrueColor [ 21.212] (--) intel(0): Integrated Graphics Chipset: Intel(R) HD Graphics 4600 [ 21.213] (--) intel(0): CPU: x86-64, sse2, sse3, ssse3, sse4.1, sse4.2, avx, avx2 [ 21.213] (**) intel(0): Framebuffer tiled [ 21.213] (**) intel(0): Pixmaps tiled [ 21.213] (**) intel(0): «Tear free» disabled [ 21.213] (**) intel(0): Forcing per-crtc-pixmaps? no

Вот же он «Integrated Graphics Chipset: Intel(R) HD Graphics 4600».

Но смущает:

00:02.0 VGA compatible controller: Intel Corporation Haswell Integrated Graphics Controller (rev 06) (prog-if 00 [VGA controller]) Subsystem: Intel Corporation Device 204a Flags: bus master, fast devsel, latency 0, IRQ 43 Memory at f7800000 (64-bit, non-prefetchable) [size=4M] Memory at e0000000 (64-bit, prefetchable) [size=256M] I/O ports at f000 [size=64] Expansion ROM at <unassigned> [disabled] Capabilities: <access denied> Kernel driver in use: i915

I-Love-Microsoft ★★★★★ ()
Последнее исправление: I-Love-Microsoft (всего исправлений: 1)
Ответ на: комментарий от i-rinat

ii libva-intel-vaapi-dri 1.0.17-1 all VAAPI driver for Intel G45 & HD Graphics family

Да, именно такая стоит... А как же поставить? Вроде ppa:xorg-edgers/ppa это и есть последние обновления? Как обновить?

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

Kernel driver in use: i915

А ядерный модуль так и называется, i915. Это нормально.

i-rinat ★★★★★ ()
Ответ на: комментарий от i-rinat

Поставил вручную, стало так:

sudo dpkg -l libva-intel-vaapi-driver
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name                  Version         Architecture    Description
+++-=====================-===============-===============-================================================
ii  libva-intel-vaapi-dri 1.2.1-2         all             VAAPI driver for Intel G45 & HD Graphics family

А ошибка всё та же:

sudo vainfo
libva: VA-API version 0.32.0
libva: va_getDriverName() returns 0
libva: Trying to open /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so
libva error: /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so init failed
libva: va_openDriver() returns -1
vaInitialize failed with error code -1 (unknown libva error),exit

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от anonymous

А зря.

Мне предстоит потом работать с аппаратным декодером видео на процессорном модуле с i7 и никакие PCI-e слоты и какая либо модицикация, никакие дискретки от nVidia, с VDPAU которых у меня проблем не было - не будет...

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от i-rinat

Кстати:

ls /usr/lib/x86_64-linux-gnu/dri
dummy_drv_video.so  i965_drv_video.so     r200_dri.so  radeon_dri.so    vmwgfx_dri.so
i915_dri.so         nouveau_dri.so        r300_dri.so  radeonsi_dri.so
i965_dri.so         nouveau_vieux_dri.so  r600_dri.so  swrast_dri.so

Есть i965_drv_video.so и его пытается открыть, а может бывает и i915_drv_video?

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

Теперь попробуй libva обновить, она тоже в raring старая. Не понятно, что именно ему сейчас не нравится. Это надо с отладчиком копаться. Будем надеяться, что обновление поможет.

i-rinat ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

а может бывает и i915_drv_video?

i915_drv_video не бывает. Intel'овский X драйвер сообщает разные имена в зависимости от железа. На твоём железе он называет себя i965. На GMA950 он назовётся «i915». А ядерный драйвер всегда называется i915.

i-rinat ★★★★★ ()
Ответ на: комментарий от i-rinat
sudo dpkg -l libva1
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name                  Version         Architecture    Description
+++-=====================-===============-===============-================================================
ii  libva1:amd64          1.2.1-2         amd64           Video Acceleration (VA) API for Linux -- runtime
sudo vainfo
libva info: VA-API version 0.34.0
libva info: va_getDriverName() returns 0
libva info: Trying to open /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so
libva info: Found init function __vaDriverInit_0_32
libva error: /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so init failed
libva info: va_openDriver() returns -1
vaInitialize failed with error code -1 (unknown libva error),exit
I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от i-rinat

sudo dpkg -i i965-va-driver_1.2.1-2_amd64.deb и получилось:

sudo vainfo
libva info: VA-API version 0.34.0
libva info: va_getDriverName() returns 0
libva info: Trying to open /usr/lib/x86_64-linux-gnu/dri/i965_drv_video.so
libva info: Found init function __vaDriverInit_0_34
libva info: va_openDriver() returns 0
vainfo: VA-API version: 0.34 (libva 1.0.15)
vainfo: Driver version: Intel i965 driver - 1.2.1
vainfo: Supported profile and entrypoints
      VAProfileMPEG2Simple            : VAEntrypointVLD
      VAProfileMPEG2Simple            : VAEntrypointEncSlice
      VAProfileMPEG2Main              : VAEntrypointVLD
      VAProfileMPEG2Main              : VAEntrypointEncSlice
      VAProfileH264Baseline           : VAEntrypointVLD
      VAProfileH264Baseline           : VAEntrypointEncSlice
      VAProfileH264Main               : VAEntrypointVLD
      VAProfileH264Main               : VAEntrypointEncSlice
      VAProfileH264High               : VAEntrypointVLD
      VAProfileH264High               : VAEntrypointEncSlice
      VAProfileVC1Simple              : VAEntrypointVLD
      VAProfileVC1Main                : VAEntrypointVLD
      VAProfileVC1Advanced            : VAEntrypointVLD

В общем, проблема была в том что были старые все библиотеки, которые не знали о новой карте.

Огромнейшее спасибо, i-rinat! Я бы ни за что на свете не догадался что даже xorg edgers содержит такие старые библиотеки, а у меня такой новый проц что его еще там нет...

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

i965-va-driver

Как-то я забыл, что это и есть настоящий драйвер. Вроде у этого пакета с libva-intel-vaapi-driver должны быть версии синхронизированы. dpkg не ругался на это?

i-rinat ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

Скачиваешь исходный код, распаковываешь, компилируешь:

$ sudo apt-get install cmake libvdpau-dev libva-dev libglib2.0-dev libswscale-dev libgl1-mesa-dev libglu1-mesa-dev
$ mkdir build; cd build
$ cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr ..
$ sudo make install

(make install можно не делать, а просто выполнить export LD_LIBRARY_PATH=., чтобы библиотеки искались в текущей директории.)

Потом выполняешь в том же терминале (в той же директории) export VDPAU_DRIVER=va_gl, а затем пытаешься mplayer'ом проиграть видео: mplayer -vc ffh264vdpau /path/to/video.mp4

Если H.264 видео успешно показывается и при этом загрузка CPU меньше, чем при обычном воспроизведении mplayer'ом, тест успешно пройден.

i-rinat ★★★★★ ()
Ответ на: комментарий от i-rinat

Попытался... Сори, пока нет возможности, пойдёт вагон зависимостей, которые придётся вручную пахать.

Чисто для воспроизведения (через vlc и smplayer) удалось заставить va-api реально работать, а вот для девелопмента нет...

Но проект «libvdpau-va-gl» это гениальная разработка! Я может дома потестирую на ноуте, там нет проблем с va-api на AMD.

I-Love-Microsoft ★★★★★ ()
Ответ на: комментарий от I-Love-Microsoft

Попытался... Сори, пока нет возможности

Ничего страшного, это всё равно была своего рода реклама. Opensource поделки тоже нуждаются в своего рода раскрутке. :)

на AMD.

Старые версии fglrx с libvdpau-va-gl часто падают, вместе с иксами.

i-rinat ★★★★★ ()
Вы не можете добавлять комментарии в эту тему. Тема перемещена в архив.